Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.h	(revision 1940)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.h	(revision 1942)
@@ -4,4 +4,6 @@
 #include <QtOpenGL>
 #include <QWaitCondition>
+
+//#include <QGLPixelBuffer>
 
 #include "Vector3.h"
@@ -11,6 +13,7 @@
 #include "GlRenderer.h"
 #include "Beam.h"
-
+#include "QtPreprocessorThread.h"
 class QWidget;
+//class QtPreprocessorThread;
 
 namespace GtpVisibilityPreprocessor {
@@ -29,4 +32,5 @@
 class TransformedMeshInstance;
 
+
 struct VssRayContainer;
 struct PvsRenderStatistics; 
@@ -34,268 +38,272 @@
 
 
-class __declspec(dllexport) QtGlRendererBuffer: public QObject, public QGLPixelBuffer, public GlRendererBuffer
+class QtGlRendererBuffer : public QObject, public QGLPixelBuffer, public GlRendererBuffer
 {
 	Q_OBJECT
-
 public:
 	QtGlRendererBuffer(const int w,
-					   const int h,
-					   SceneGraph *sceneGraph,
-					   ViewCellsManager *viewcells,
-					   KdTree *tree);
-
-	~QtGlRendererBuffer();
-
-	/** Evaluates render cost of a point sample.
-	@param sample the render cost sample to be evaluated
-	@param useOcclusionQueries if occlusion queries should be used or item buffer
-	@param threshold number of pixels / samples from where an object is considered visible.
-	*/
-	void EvalRenderCostSample(RenderCostSample &sample,
-		const bool useOcclusionQueries,
-		const int threshold);
-
-	/** Evaluates render cost of a number of point samples. The point samples
-	are distributed uniformly over the defined view space.
-
-	@param numSamples the number of point samples taken
-	@param samples stores the taken point samples in a container
-	@param useOcclusionQueries if occlusion queries should be used or item buffer
-	@param threshold number of pixels / samples from where an object is considered visible.
-	*/
-	void SampleRenderCost(const int numSamples, 
-		vector<RenderCostSample> &samples,
-		const bool useOcclusionQueries,
-		const int threshold = 0);
-
-	void
-		EvalPvsStat();
-
-	void
-		ClearErrorBuffer();
-
-	virtual int GetWidth() const { return width(); }
-	virtual int GetHeight() const { return height(); }
-
-	void SampleBeamContributions(
-			Intersectable *sourceObject,
-			Beam &beam,
-			const int samples,
-			BeamSampleStatistics &stat
-		);
-
-	void
-		SampleViewpointContributions(
-			Intersectable *sourceObject,
-			const Vector3 viewPoint,
-			Beam &beam,
-			const int desiredSamples,
-			BeamSampleStatistics &stat
-		);
-
-	void InitGL();
-
-	/** Computes rays from information gained with hw sampling
-	*/
-	void ComputeRays(Intersectable *sourceObj, VssRayContainer &rays);
-
-	float GetPixelError(int &pvsSize);
-
-	int ComputePvs(ObjectContainer &objects, ObjectContainer &pvs) const;
-
-
-private:
-
-	void SetupProjectionForViewPoint(const Vector3 &viewPoint, 
-									 const Beam &beam, 
-									 Intersectable *sourceObject);
-
-
-public:
-signals:
-	void UpdatePvsErrorItem(int i, GlRendererBuffer::PvsErrorEntry &);
-};
-
-
-class __declspec(dllexport) QtRendererControlWidget : public QWidget
+		const int h,
+		SceneGraph *sceneGraph,
+		ViewCellsManager *viewcells,
+		KdTree *tree);
+
+  ~QtGlRendererBuffer() {}
+
+  virtual void MakeCurrent();
+  virtual void DoneCurrent();
+
+  virtual int GetWidth() const { return width(); }
+  virtual int GetHeight() const { return height(); }
+
+  int ComputePvs() const { return 0; }
+  
+  float
+  GetPixelError(int &pvsSize);
+  
+  int ComputePvs(ObjectContainer &objects, ObjectContainer &pvs) const;
+     
+  
+  
+  
+public:
+  signals:
+  void UpdatePvsErrorItem(int i, GlRendererBuffer::PvsErrorEntry &);
+};
+
+
+class QtRendererControlWidget : public QWidget
 {
-	Q_OBJECT
-public:
-
-	QListWidget *mPvsErrorWidget;
-
-	QtRendererControlWidget(QWidget * parent = 0, Qt::WFlags f = 0);
-
-public slots:
-
-	void FocusNextPvsErrorFrame();
-	void UpdatePvsErrorItem(int i,
-		GlRendererBuffer::PvsErrorEntry &);
-
-signals:
-
-	void SetViewCellGranularity(int);
-	void SetSceneCut(int);
-	void SetTopDistance(int);
-	void SetVisibilityFilterSize(int);
-	void SetSpatialFilterSize(int);
-
-	void SetRenderFilter(bool);
-	void SetUseFilter(bool);
-	void SetUseSpatialFilter(bool);
-	void SetRenderErrors(bool);
-	void SetShowViewCells(bool);
-	void SetShowRenderCost(bool);
-	void SetShowPvsSizes(bool);
-	void SetTopView(bool);
-	void SetCutViewCells(bool);
-	void SetCutScene(bool);
-
-
-};
-
-
-class __declspec(dllexport) QtGlRendererWidget : public QGLWidget, public GlRendererWidget
+  Q_OBJECT
+public:
+
+  QListWidget *mPvsErrorWidget;
+
+  QtRendererControlWidget(QWidget * parent = 0, Qt::WFlags f = 0);
+
+  public slots:
+
+  void FocusNextPvsErrorFrame();
+  void UpdatePvsErrorItem(int i,
+						  GlRendererBuffer::PvsErrorEntry &);
+
+  signals:
+
+  void ComputeVisibility();
+  void StopComputation();
+  void SetRandomViewPoint();
+  void UpdateAllPvs();
+  void SetViewCellGranularity(int);
+  void SetTransferFunction(int);
+  void SetSceneCut(int);
+  void SetTopDistance(int);
+  void SetVisibilityFilterSize(int);
+  void SetSpatialFilterSize(int);
+
+  void SetShowRays(bool);
+  void SetRenderFilter(bool);
+  void SetRenderVisibilityEstimates(bool);
+  void SetUseFilter(bool);
+  void SetUseSpatialFilter(bool);
+  void SetRenderErrors(bool);
+  void SetRenderBoxes(bool);
+  void SetShowViewCells(bool);
+  void SetShowRenderCost(bool);
+  void SetShowPvsSizes(bool);
+  void SetTopView(bool);
+  void SetCutViewCells(bool);
+  void SetCutScene(bool);
+
+};
+
+
+class QtGlRendererWidget : public QGLWidget, public GlRendererWidget
 {
-	Q_OBJECT
-public:
-
-	// point of the last mouse click used for movement in the scene
-	Vector3 mousePoint;
-
-	bool mTopView;
-	bool mRenderViewCells;
-	bool mCutViewCells;
-	bool mCutScene;
-	bool mRenderErrors;
-	bool mRenderFilter;
-	bool mUseFilter;
-	bool mUseSpatialFilter;
-	bool mShowRenderCost;
-
-	bool mShowPvsSizes;
-	float mSpatialFilterSize;
-
-	Plane3 mSceneCutPlane;
-	float mTopDistance;
-
-	// some statistics
-	int mPvsSize;
-	float mRenderError;
-
-	QtRendererControlWidget *mControlWidget;
-
-	QtGlRendererWidget(SceneGraph *sceneGraph,
-		ViewCellsManager *viewcells,
-		KdTree *tree,
-		QWidget * parent = 0, const QGLWidget * shareWidget = 0, Qt::WFlags f = 0
-		);
-
-	QtGlRendererWidget() {};
-
-	virtual void SetupCamera();
-
-	void initializeGL() {
-		InitGL();
-	}
-	void resizeGL(int w, int h);
-	void paintGL();
-	void timerEvent(QTimerEvent *) {
-		update();
-	}
-
-	void mousePressEvent(QMouseEvent *);
-	void mouseReleaseEvent(QMouseEvent *);
-	void mouseMoveEvent(QMouseEvent *);
-
-	void keyPressEvent ( QKeyEvent * e ) ;
-
-	void
-		RenderPvs();
-
-	float
-		RenderErrors();
-	void
-		RenderInfo();
-
-	virtual int GetWidth() const { return width(); }
-	virtual int GetHeight() const { return height(); }
-
-	virtual void
-		SetupProjection(const int w, const int h, const float angle = 70.0f);
-
-	void
-		RenderViewCells();
-
-public slots:
-
-	void SetRenderErrors(bool b) {
-		mRenderErrors = b;
-		updateGL();
-	}
-
-	void SetRenderFilter(bool b) {
-		mRenderFilter = b;
-		updateGL();
-	}
-
-	void SetUseFilter(bool b) {
-		mUseFilter = b;
-		updateGL();
-	}
-
-	void SetUseSpatialFilter(bool b) {
-		mUseSpatialFilter = b;
-		updateGL();
-	}
-
-
-	void
-		SetViewCellGranularity(int number);
-
-	void
-		SetVisibilityFilterSize(int number);
-
-	void
-		SetSpatialFilterSize(int number);
-
-	void
-		SetSceneCut(int cut);
-
-	void
-		SetTopDistance(int dist);
-
-	void SetShowViewCells(bool b) {
-		mRenderViewCells = b;
-		updateGL();
-	}
-
-	void SetShowRenderCost(bool b) {
-		mShowRenderCost = b;
-		updateGL();
-	}
-
-	void SetShowPvsSizes(bool b) {
-		mShowPvsSizes = b;
-		updateGL();
-	}
-
-	void SetTopView(bool b) {
-		mTopView = b;
-		updateGL();
-	}
-
-	void SetCutViewCells(bool b) {
-		mCutViewCells = b;
-		updateGL();
-	}
-	void SetCutScene(bool b) {
-		mCutScene = b;
-		updateGL();
-	}
-
-	// matt: dummy function, must be provided by bittner
-	void RenderRenderCost() {}
-
+  Q_OBJECT
+public:
+
+  // point of the last mouse click used for movement in the scene
+  Vector3 mousePoint;
+
+  bool mTopView;
+  bool mRenderViewCells;
+  bool mCutViewCells;
+  bool mCutScene;
+  bool mRenderErrors;
+  bool mRenderFilter;
+  bool mRenderVisibilityEstimates;
+  bool mUseFilter;
+  bool mUseSpatialFilter;
+  bool mShowRenderCost;
+  bool mShowRays;
+
+  bool mShowPvsSizes;
+  float mSpatialFilterSize;
+  
+  Plane3 mSceneCutPlane;
+  float mTopDistance;
+
+  // some statistics
+  int mPvsSize;
+  float mRenderError;
+  float mTransferFunction;
+
+  
+  QtRendererControlWidget *mControlWidget;
+
+  QtPreprocessorThread *mPreprocessorThread;
+  
+  QtGlRendererWidget(SceneGraph *sceneGraph,
+					 ViewCellsManager *viewcells,
+					 KdTree *tree,
+					 QWidget * parent = 0, const QGLWidget * shareWidget = 0, Qt::WFlags f = 0
+					 );
+  
+  QtGlRendererWidget() {};
+
+  void SetThread(QtPreprocessorThread *t) {
+	mPreprocessorThread = t;
+  }
+  void
+  RenderRenderCost();
+
+  virtual void SetupCamera();
+
+  void initializeGL() {
+	InitGL();
+  }
+  void resizeGL(int w, int h);
+  void paintGL();
+  void timerEvent(QTimerEvent *) {
+	  update();
+  }
+
+  void mousePressEvent(QMouseEvent *);
+  void mouseReleaseEvent(QMouseEvent *);
+  void mouseMoveEvent(QMouseEvent *);
+
+  void keyPressEvent ( QKeyEvent * e ) ;
+
+  void
+  RenderPvs();
+
+  float
+  RenderErrors();
+  void
+  RenderInfo();
+
+  virtual int GetWidth() const { return width(); }
+  virtual int GetHeight() const { return height(); }
+
+  // virtual void
+  //  SetupProjection(const int w, const int h, const float angle = 70.0f);
+
+  virtual void
+  SetupCameraProjection(const int w, const int h, const float angle = 70.0f);
+
+  void
+  RenderViewCells();
+
+
+  virtual void Show() {
+	show();
+  }
+
+ public slots:
+
+ void UpdateAllPvs();
+  void ComputeVisibility();
+  void StopComputation();
+  void SetRandomViewPoint();
+
+ void SetRenderErrors(bool b) {
+   mRenderErrors = b;
+   updateGL();
+ }
+
+  void SetRenderBoxes(bool b) {
+	mRenderBoxes = b;
+	updateGL();
+  }
+
+ void SetRenderFilter(bool b) {
+   mRenderFilter = b;
+   updateGL();
+ }
+
+  void SetRenderVisibilityEstimates(bool b) {
+	mRenderVisibilityEstimates = b;
+   updateGL();
+ }
+
+  void SetUseFilter(bool b) {
+   mUseFilter = b;
+   mPvsCache.Reset();
+   updateGL();
+ }
+
+  void SetUseSpatialFilter(bool b) {
+	mUseSpatialFilter = b;
+	mPvsCache.Reset();
+	updateGL();
+  }
+
+  
+  void
+  SetViewCellGranularity(int number);
+
+  void
+  SetTransferFunction(int number) {
+	mTransferFunction = number/1000.0f;
+	updateGL();
+  }
+
+  void
+  SetVisibilityFilterSize(int number);
+
+  void
+  SetSpatialFilterSize(int number);
+  
+  void
+  SetSceneCut(int cut);
+  
+  void
+  SetTopDistance(int dist);
+  
+  void SetShowViewCells(bool b) {
+	mRenderViewCells = b;
+	updateGL();
+  }
+
+  void SetShowRays(bool b) {
+	mShowRays = b;
+	updateGL();
+  }
+
+  void SetShowRenderCost(bool b) {
+	mShowRenderCost = b;
+	updateGL();
+  }
+
+  void SetShowPvsSizes(bool b) {
+	mShowPvsSizes = b;
+	updateGL();
+  }
+
+  void SetTopView(bool b) {
+	mTopView = b;
+	updateGL();
+  }
+
+  void SetCutViewCells(bool b) {
+	mCutViewCells = b;
+	updateGL();
+  }
+  void SetCutScene(bool b) {
+	mCutScene = b;
+	updateGL();
+  }
+
+  signals:
+  void PvsUpdated();
 };
 
@@ -305,27 +313,26 @@
 	Q_OBJECT
 public:
-	QtGlDebuggerWidget(QtGlRendererBuffer *buf, QWidget *parent = NULL);
-	~QtGlDebuggerWidget();
-	void initializeGL();
-	void resizeGL(int w, int h);
-	void paintGL();
-	void timerEvent(QTimerEvent *) { update(); }
-	void mousePressEvent(QMouseEvent *) { killTimer(timerId); }
-	void mouseReleaseEvent(QMouseEvent *) { timerId = startTimer(20); }
-
-	void initCommon();
-	void initPbuffer();
-
-
-	QtGlRendererBuffer *mRenderBuffer;
-
-	Beam mBeam;
-	int mSamples;
-	Intersectable *mSourceObject;
+    QtGlDebuggerWidget(QtGlRendererBuffer *buf, QWidget *parent = NULL);
+    ~QtGlDebuggerWidget();
+    void initializeGL();
+    void resizeGL(int w, int h);
+    void paintGL();
+    void timerEvent(QTimerEvent *) { update(); }
+    void mousePressEvent(QMouseEvent *) { killTimer(timerId); }
+    void mouseReleaseEvent(QMouseEvent *) { timerId = startTimer(20); }
+
+    void initCommon();
+    void initPbuffer();
+
+  
+	 QtGlRendererBuffer *mRenderBuffer;
+
+	 Beam mBeam;
+	 int mSamples;
+	 Intersectable *mSourceObject;
 
 private:
-
-	GLuint dynamicTexture;
-	int timerId;
+    GLuint dynamicTexture;
+    int timerId;
 };
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlViewer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlViewer.cpp	(revision 1942)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlViewer.cpp	(revision 1942)
@@ -0,0 +1,190 @@
+// ===================================================================
+// $Id$
+#ifdef USE_QT
+
+// Qt headers
+#include <QtGui>
+#include <QtOpenGL>
+
+// C++ standard headers
+#include <cmath>
+
+// local headers
+#include "common.h"
+#include "QtGlViewer.h"
+#include "QtGlRenderer.h"
+#include "Trackball.h"
+#include "RssPreprocessor.h"
+#include "SceneGraph.h"
+
+
+namespace GtpVisibilityPreprocessor {
+
+QtGlRendererWidget *renderer;
+
+QtGlViewer::QtGlViewer(QWidget *parent,
+					   QtGlRendererWidget *renderer):
+  QGLWidget(parent), mRenderer(renderer)
+{
+	scale = 1.0f;
+	mWireframe = false;
+	trackball(manipulatorLastQuat, 0.0f, 0.0f, 0.0f, 0.0f);
+	connect(renderer, SIGNAL(PvsUpdated()), this, SLOT(updateGL()));
+}
+  
+QSize
+QtGlViewer::minimumSizeHint() const
+{
+  return QSize(100, 100);
+}
+
+QSize
+QtGlViewer::sizeHint() const {
+  return QSize(500, 500);
+}
+  
+// This method has to be rendefined by all renderer implementations
+void
+QtGlViewer::RenderScene()
+{
+	mRenderer->mFrame++;
+	
+	// render into the right side of the window buffer
+	if (mRenderer->mRenderViewCells) 
+	  mRenderer->RenderViewCells();
+	
+	mRenderer->RenderPvs();
+	
+// 	if (mRenderer->mShowRays) {
+// 	  RssPreprocessor *p = (RssPreprocessor *)
+// 			mRenderer->mViewCellsManager->GetPreprocessor();
+// 	  if (p->mRssTree) {
+// 			VssRayContainer rays;
+// 			p->mRssTree->CollectRays(rays, 10000);
+// 			mRenderer->RenderRays(rays);
+// 	  }
+// 	}
+	
+	if (mRenderer->mShowRenderCost) 
+	  mRenderer->RenderRenderCost();
+
+	glColor3f(1.0f, 1.0f, 1.0f);
+	mRenderer->RenderInfo();
+}
+
+
+void
+QtGlViewer::initializeGL()
+{  
+  const char *vendorString, *rendererString, *versionString, *extString;
+
+  // get GL info
+  vendorString = (const char *) glGetString(GL_VENDOR);
+  rendererString = (const char *) glGetString(GL_RENDERER);
+  versionString = (const char *) glGetString(GL_VERSION);
+  extString = (const char *) glGetString(GL_EXTENSIONS);
+  
+  Debug << "Info: GL Vendor = "<<vendorString<<endl
+        << "Info: GL Renderer = "<<rendererString<<endl
+        << "Info: GL Version = "<<versionString<<endl
+        << "Info: GL Extensions = "<<extString<<endl<<flush;
+
+
+  return;
+}
+
+void
+QtGlViewer::paintGL()
+{
+  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+  glLoadIdentity();
+
+  float m[4][4];
+
+  glLoadIdentity();
+  gluLookAt(0.0, 0.0, 1.0,  /* eye is at (0,0,30) */
+						0.0, 0.0, 0.0,      /* center is at (0,0,0) */
+						0.0, 1.0, 0.);      /* up is in positive Y direction */
+  
+  build_rotmatrix(m, manipulatorLastQuat);
+  glMultMatrixf(&m[0][0]);
+
+  float s = scale*20.0f/Magnitude(mRenderer->mSceneGraph->GetBox().Diagonal());
+  glScalef(s, s, s);
+  
+  Vector3 t = -mRenderer->mSceneGraph->GetBox().Center();
+  glTranslatef(t.x, t.y, t.z);
+
+	RenderScene();
+}
+
+void
+QtGlViewer::resizeGL(int width, int height)
+{
+  glViewport(0, 0, width, height);
+  
+  glMatrixMode(GL_PROJECTION);
+  glLoadIdentity();
+  gluPerspective(70.0, 1.0, 0.1, 100.0);
+  //  glOrtho(-0.5*width/height, +0.5*width/height, 0.5, -0.5, 4.0, 15.0);
+  glMatrixMode(GL_MODELVIEW);
+}
+
+
+void
+QtGlViewer::mousePressEvent(QMouseEvent *event)
+{
+  lastPos = event->pos();
+}
+
+void
+QtGlViewer::keyPressEvent ( QKeyEvent * e )
+{
+  switch (e->key()) {
+  case Qt::Key_W:
+		mWireframe  = !mWireframe;
+		updateGL();
+  default:
+		e->ignore();
+		break;
+  }
+  updateGL();
+}
+
+void
+QtGlViewer::mouseMoveEvent(QMouseEvent *event)
+{
+  int dx = event->x() - lastPos.x();
+  int dy = event->y() - lastPos.y();  
+  
+  if (event->modifiers() & Qt::CTRL)
+		{
+			scale = scale*(1.0f - dy/(float)height());
+			if (scale < 0.01f)
+				scale = 0.01f;
+			updateGL();
+		}
+  else {
+		float W = width();
+		float H = height();
+		int x = event->x();
+		int lastX = lastPos.x();
+		int y = event->y();
+		int lastY = lastPos.y();
+	
+		float quat[4];
+		trackball(quat,
+							(2.0 * lastX - W) / W,
+							(H - 2.0 * lastY) / H,
+							(2.0 * x - W) / W,
+							(H - 2.0 * y) / H
+							);
+		add_quats(quat, manipulatorLastQuat, manipulatorLastQuat);
+  }
+  
+  lastPos = event->pos();
+updateGL();
+}
+}
+
+#endif
Index: GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 1931)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 1942)
@@ -43,5 +43,4 @@
 	useGlDebugger false
 # 0 = INTERNAL 		1 = MLRT
-
 	rayCastMethod 1
 	
@@ -62,5 +61,5 @@
 	applyVisibilitySpatialFilter false
 	visibilityFilterWidth	0.01
-	exportVisibility false
+	exportVisibility true
 	visibilityFile visibility.xml
 	loadMeshes false
@@ -98,10 +97,12 @@
 
 #	distributions rss+spatial+object_direction
-	distributions rss+object_direction+spatial+object+direction
+#	distributions rss+object_direction+spatial+object+direction
+	distributions object_direction+spatial+object+direction
+#	distributions rss+object_direction
 #	distributions object_direction
 
 	samplesPerPass 1000000
 	initialSamples 2000000
-	vssSamples 150000000
+	vssSamples 20000000
 	vssSamplesPerPass 5000000
 	useImportanceSampling true
@@ -132,5 +133,5 @@
 #	splitType heuristic
 
-	minRays		50
+	minRays		200
 	minSize		0.001
  	maxCostRatio 1.0
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.h	(revision 1901)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.h	(revision 1942)
@@ -269,4 +269,9 @@
   void ComputeContributions(VssRayContainer &vssRays);
 
+  // update distributions with new rays
+  // warning: some rays can get deleted (if maintained internally by the
+  // particular distribution)!
+  void UpdateDistributions(VssRayContainer &vssRays);
+
   void
   UpdateRatios();
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1935)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1942)
@@ -31,7 +31,7 @@
 #define USE_RAY_LENGTH_AS_CONTRIBUTION 0
 #define DIST_WEIGHTED_CONTRIBUTION 0
-#define SUM_RAY_CONTRIBUTIONS 0
-#define AVG_RAY_CONTRIBUTIONS 1
-#define CONTRIBUTION_RELATIVE_TO_PVS_SIZE 1
+#define SUM_RAY_CONTRIBUTIONS 1
+#define AVG_RAY_CONTRIBUTIONS 0
+#define CONTRIBUTION_RELATIVE_TO_PVS_SIZE 0
 #define PVS_ADD_DIRTY 1
 
@@ -1996,6 +1996,20 @@
   stat.avgFilterRadius = 0;
   stat.avgFilterRatio = 0;
+  stat.avgRelPvsIncrease = 0.0f;
+  stat.devRelPvsIncrease = 0.0f;
   
-  for (; it != mViewCells.end(); ++ it) 
+  if (mPerViewCellStat.size() != mViewCells.size()) {
+	// reset the pvs size array after the first call to this routine
+	mPerViewCellStat.resize(mViewCells.size());
+	for (int i=0; i < mPerViewCellStat.size(); i++) {
+	  mPerViewCellStat[i].pvsSize = 0.0f;
+	  mPerViewCellStat[i].relPvsIncrease = 0.0f;
+	}
+  }
+  int i;
+  bool evaluateFilter;
+  Environment::GetSingleton()->GetBoolValue("Preprocessor.evaluateFilter", evaluateFilter);
+
+  for (i=0; it != mViewCells.end(); ++ it, i++) 
 	{
 	  ViewCell *viewcell = *it;
@@ -2010,6 +2024,13 @@
 		stat.avgPvs += pvsCost;
 
-		bool evaluateFilter;
-		Environment::GetSingleton()->GetBoolValue("Preprocessor.evaluateFilter", evaluateFilter);
+
+		if (mPerViewCellStat[i].pvsSize > 0.0f)
+		  mPerViewCellStat[i].relPvsIncrease = (pvsCost - mPerViewCellStat[i].pvsSize)/mPerViewCellStat[i].pvsSize;
+		
+		stat.avgRelPvsIncrease += mPerViewCellStat[i].relPvsIncrease;
+		
+		// update the pvs size
+		mPerViewCellStat[i].pvsSize = pvsCost;
+		
 		
 		
@@ -2040,4 +2061,6 @@
 	  }
 	}
+
+  
   
   if (stat.viewcells) {
@@ -2046,6 +2069,15 @@
 	stat.avgFilterContribution/=stat.viewcells;
 	stat.avgFilterRadius/=stat.viewcells;
-	stat.avgFilterRatio/=stat.viewcells;
+	stat.avgFilterRatio/=stat.viewcells; 
+	stat.avgRelPvsIncrease/=stat.viewcells;
+
+	// evaluate std deviation of relPvsIncrease
+	float sum=0.0f;
+	for (i=0; i < stat.viewcells; i++) {
+	  sum += sqr(mPerViewCellStat[i].relPvsIncrease - stat.avgRelPvsIncrease);
+	}
+	stat.devRelPvsIncrease = sqrt(sum/stat.viewcells);
   }
+  
 }
 
@@ -2063,4 +2095,6 @@
   s<<"#MAX_PVS\n"<<pvsStat.maxPvs<<endl;
   s<<"#MIN_PVS\n"<<pvsStat.minPvs<<endl;
+  s<<"#AVG_REL_PVS_INCREASE\n"<<pvsStat.avgRelPvsIncrease<<endl;
+  s<<"#DEV_REL_PVS_INCREASE\n"<<pvsStat.devRelPvsIncrease<<endl;
 }
 
@@ -2178,48 +2212,59 @@
 												   const bool addRays)
 {
-	// check if we are outside of view space
+  // check if we are outside of view space
 	if (!obj || !viewCell->GetValid())
 		return;
-
+	
 	// if ray not outside of view space
 	float relContribution = 0.0f;
 	float absContribution = 0.0f;
-
-	// todo: maybe not correct for kd node pvs
-	if (viewCell->GetPvs().GetSampleContribution(obj,
-												 ray.mPdf,
-												 relContribution))
-	{
-		absContribution = 1.0f;
-	}
-	
-	// $$ clear the relative contribution as it is currently not correct anyway
-	relContribution = 0.0f;
-
-	if (absContribution == 1.0f)
-	{
-		++ ray.mPvsContribution;
-		relContribution = 1.0f;
-
-		if (addRays) 
-		{
-			AddSampleToPvs(viewCell->GetPvs(), obj, ray.mPdf);
-		}
-
+	
+	if (obj) 
+	  {
+		// todo: maybe not correct for kd node pvs
+		if (addRays) {
+		  float pdf = viewCell->GetPvs().AddSampleDirtyCheck(obj, ray.mPdf);
+		  if (pdf == ray.mPdf) {
+			absContribution = 1.0f;
+			if (viewCell->GetPvs().RequiresResort()) 
+			  viewCell->GetPvs().SimpleSort();
+		  }
+			  } else {
+				if (viewCell->GetPvs().GetSampleContribution(
+															 obj,
+															 ray.mPdf,
+															 relContribution))
+				  absContribution = 1.0f;
+			  }
+		// $$ clear the relative contribution as it is currently not correct anyway
+		relContribution = 0.0f;
+		
+		if (absContribution == 1.0f) {
+		  ++ ray.mPvsContribution;
+		  relContribution = 1.0f;
+		  
+		  
+#if CONTRIBUTION_RELATIVE_TO_PVS_SIZE
+		  relContribution /= viewcell->GetPvs().GetSize();
+#endif
+		  
 #if DIST_WEIGHTED_CONTRIBUTION 
-		// recalculate the contribution - weight the 1.0f contribution by the sqr distance to the
-		// object-> a new contribution in the proximity of the viewcell has a larger weight!
-		relContribution /= SqrDistance(GetViewCellBox(viewcell).Center(), pt);
-				  
+		  // recalculate the contribution - weight the 1.0f contribution by the sqr distance to the
+		  // object-> a new contribution in the proximity of the viewcell has a larger weight!
+		  relContribution /= SqrDistance(GetViewCellBox(viewcell).Center(),
+										 ray.mTermination);
+		  
 #endif
-	}
-
+		}
+		
 #if SUM_RAY_CONTRIBUTIONS || AVG_RAY_CONTRIBUTIONS
-	ray.mRelativePvsContribution += relContribution;
+		ray.mRelativePvsContribution += relContribution;
 #else
-	// recalculate relative contribution - use max of AbsContribution
-	if (ray.mRelativePvsContribution < absContribution)
-		ray.mRelativePvsContribution = absContribution;
+		// recalculate relative contribution - use max of Rel Contribution
+		if (ray.mRelativePvsContribution < relContribution)
+		  ray.mRelativePvsContribution = relContribution;
 #endif
+	  }
+	
 }
 
@@ -2243,6 +2288,8 @@
 	float tmin = 0, tmax = 1.0;
 
-	if (!GetViewSpaceBox().GetRaySegment(hray, tmin, tmax) || (tmin > tmax))
-		return 0;
+	if (!GetViewSpaceBox().GetRaySegment(hray, tmin, tmax) || (tmin > tmax)) {
+	  //	  cerr<<"ray outside view space box\n";
+	  return 0;
+	}
 
 	Vector3 origin = hray.Extrap(tmin);
@@ -2254,9 +2301,10 @@
 	CastLineSegment(origin, termination, viewCells);
 
+	
 	if (storeViewCells)
 	{	
-		// copy viewcells memory efficiently
-		ray.mViewCells.reserve(viewCells.size());
-		ray.mViewCells = viewCells;
+	  // copy viewcells memory efficiently
+	  ray.mViewCells.reserve(viewCells.size());
+	  ray.mViewCells = viewCells;
 	}
 
@@ -2280,11 +2328,11 @@
 #if USE_RAY_LENGTH_AS_CONTRIBUTION
 	float c = 0.0f;
-	if (obj) 
-		c = ray.Length();
+	if (terminationObj) 
+	  c = ray.Length();
 	ray.mRelativePvsContribution = ray.mPvsContribution = c;
 	return c;
 #else
-	return ABS_CONTRIBUTION_WEIGHT * ray.mPvsContribution +
-		(1.0f - ABS_CONTRIBUTION_WEIGHT) * ray.mRelativePvsContribution;
+	return ABS_CONTRIBUTION_WEIGHT*ray.mPvsContribution +
+	  (1.0f - ABS_CONTRIBUTION_WEIGHT)*ray.mRelativePvsContribution;
 #endif
 }
@@ -2897,5 +2945,5 @@
 		sqrt((float)objectSamples);
 	  
-	  //	cout<<"lr="<<localRadius<<" gr="<<globalRadius<<endl;
+	  //	  cout<<"os="<<objectSamples<<" lr="<<localRadius<<" gr="<<globalRadius<<endl;
 	  
 	  // now compute the filter size
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 1941)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 1942)
@@ -66,5 +66,6 @@
   //  mViewCellsManager->GetViewPoint(mViewPoint);
 
-  mViewPoint = mSceneGraph->GetBox().Center();
+  viewCellsManager->GetViewPoint(mViewPoint);
+	//mSceneGraph->GetBox().Center();
   mViewDirection = Vector3(0,0,1);
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtGlViewer.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtGlViewer.h	(revision 1936)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtGlViewer.h	(revision 1942)
@@ -12,6 +12,5 @@
 class QtGlViewer : public QGLWidget
 {
-	
-	//Q_OBJECT
+  Q_OBJECT
 
 	friend class QtGlRendererWidget;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Pvs.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Pvs.h	(revision 1925)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Pvs.h	(revision 1942)
@@ -615,9 +615,8 @@
   // sample not found yet => search further in the unsorted part
   if (!found && checkDirty) {
-	vector<PvsEntry<T, S> >::const_iterator dit, dit_end = mEntries.end();
-	
-	for (dit = sorted_end; (dit != dit_end) && ((*dit).mObject != sample); ++ dit) ;
-	
-	if (dit != dit_end)
+	
+	for (it = sorted_end; (it != mEntries.end()) && ((*it).mObject != sample); ++ it) ;
+	
+	if (it != mEntries.end())
 	  found = true;
   }
@@ -653,10 +652,10 @@
 	}
 	else 
-	{
+	  {
 		PvsEntry<T, S> entry(sample, pdf);
 		mEntries.insert(it, entry);
 		++ mLastSorted;
 		return pdf;
-	}
+	  }
 }
 
@@ -706,5 +705,5 @@
 
 	vector<PvsEntry<T, S> >::iterator it;
-	const bool entryFound = Find(sample, it);
+	bool entryFound = Find(sample, it);
 
 	if (entryFound) {
Index: GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp	(revision 1867)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp	(revision 1942)
@@ -2,4 +2,5 @@
 #include "VssRay.h"
 #include "Preprocessor.h"
+#include "SceneGraph.h"
 
 #ifdef GTP_INTERNAL
@@ -125,7 +126,7 @@
 	float backward_dist[16];
 
-
-	Vector3 min = sbox.Min();
-	Vector3 max = sbox.Max();
+	
+	Vector3 min = mPreprocessor.mSceneGraph->GetBox().Min();
+	Vector3 max = mPreprocessor.mSceneGraph->GetBox().Max();
 
 	for (i=0; i < num; i++) {
Index: GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp	(revision 1931)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp	(revision 1942)
@@ -2299,7 +2299,5 @@
 {
   Vector3 origin = sbox.GetPoint(Vector3(params[0], params[1], params[2]));
-
   Vector3 dirVector = sDirBBox.GetPoint(Vector3(params[3], params[4], 0.0f));
-
   Vector3 direction = VssRay::GetInvDirParam(dirVector.x, dirVector.y);
   
@@ -2308,15 +2306,15 @@
   float minT, maxT;
   
-  float boxSize = Magnitude(sbox.Size());
   // compute interection of the ray with the box
 #if 1
   if (sbox.ComputeMinMaxT(origin, direction, &minT, &maxT) && minT < maxT)
-	dist = (maxT + 0.0f*boxSize);
+	dist = (maxT + Limits::Small);
 #else
+  float boxSize = Magnitude(sbox.Size());
   dist = 0.5f*boxSize;
 #endif
   
   origin += direction*dist;
-
+  
   //Debug<<"dir vector.x="<<dirVector.x<<"direction'.x="<<atan2(direction.x, direction.y)<<endl;
   rays.push_back(SimpleRay(origin,
@@ -2765,5 +2763,5 @@
 	  sumContributions += c1;
 	  if (c1 > maxContribution)
-			maxContribution = c1;
+		maxContribution = c1;
 	  
 	  //$$ 20.7. changed to sqr to pronouce higher contribution so that
@@ -2806,5 +2804,5 @@
 		pow(((weightAbsContributions*sumContributions +
 			  (1.0f - weightAbsContributions)*sumRelContributions)/sumWeights), 1.0f);
-#else 1
+#else 
 	  leaf->mImportance =
 		(weightAbsContributions*maxContribution +
